/**
 * @file FootyDocSearch.cpp
 * @brief hLgǗNXB̃t@CŌn̎܂B
 * @author Shinji Watanabe
 * @version 1.0
 * @date Jan.22.2008
 */

#include "FootyDoc.h"
#include "RegExpLetters.h"

#define FLAG_ON(x)		((nFlags & x) != 0)


/**
 * CFootyDoc::Search
 * @brief s鏈
 * @param szText 
 * @param nFlags 邽߂̃tO(Footy2.hɒ`)
 */
bool CFootyDoc::Search(const wchar_t *szText, int nFlags)
{
	CRegExpContainer cSearchText;
	
	// K\ɂ
	if (FLAG_ON(SEARCH_REGEXP))
	{
	}
	else
	{
		cSearchText.AddRegExp(new CRegExpLetters(szText, FLAG_ON(SEARCH_IGNORECASE)));
	}
	
	// ̎s
	CEditPosition cStartPos;
	if (FLAG_ON(SEARCH_FROMCURSOR))
	{
		if ( IsSelecting() )
		{
			cStartPos = FLAG_ON(SEARCH_BACK) ? *GetSelStart() : *GetSelEnd();
		}
		else
		{
			cStartPos = m_cCaretPos;
		}
	}
	else
	{
		cStartPos.SetPosition(m_lsLines.begin(), 0);
	}
	return SearchText(&cStartPos, &cSearchText, FLAG_ON(SEARCH_BACK));
}

/**
 * CFootyDoc::SearchText
 * @brief s鏈
 * @param pStart Jnʒu
 * @param pRegElement K\vf
 * @param bBackward 
 * @return ƂtrueԂ
 */
bool CFootyDoc::SearchText(CEditPosition *pStart, CRegExpElement *pRegElement, bool bBackward)
{
	// 錾
	CEditPosition cEndPos;							//!< IIʒu
	LinePt pNowLine = pStart->GetLinePointer();		//!< ̍sʒu
	size_t nNowPosition = pStart->GetPosition();	//!< ̌
	
	// ֌鏈̏ꍇ
	if (!bBackward)
	{
		// sƂɃ[v
		for (;pNowLine != m_lsLines.end();)
		{
			// ƂɃ[v
			for (;nNowPosition != pNowLine->GetLineLength();nNowPosition++)
			{
				if (pRegElement->Search(pNowLine,nNowPosition,&cEndPos,m_lsLines.end()))
				{
					SelectSearchedWord(pNowLine,nNowPosition,&cEndPos);
					return true;
				}
			}

			// ̍sֈړ
			pNowLine++;
			nNowPosition = 0;
		}
	}
	else
	{
		// sƂɃ[v
		for (;;)
		{
			// ƂɃ[v
			if ( nNowPosition != 0 )
			{
				for (nNowPosition-- ; ; nNowPosition--)
				{
					if (pRegElement->Search(pNowLine,nNowPosition,&cEndPos,m_lsLines.end()))
					{
						SelectSearchedWord(pNowLine,nNowPosition,&cEndPos);
						return true;
					}
					if (nNowPosition == 0)break;
				}
			}

			// ̍sֈړ
			if (pNowLine == m_lsLines.begin())break;
			pNowLine--;
			nNowPosition = pNowLine->GetLineLength();
		}
	}
	return false;
}


/**
 * CFootyDoc::SelectSearchedWord
 * @brief ̌ʌtI
 */
void CFootyDoc::SelectSearchedWord(LinePt pNowLine,size_t nPosition,CEditPosition *pEndPos)
{
	CEditPosition cStartSelect;			//!< ƂAIJnʒuƂʒu

	cStartSelect.SetPosition(pNowLine,nPosition);
	*GetCaretPosition() = *pEndPos;
	SetSelectStart(&cStartSelect);
	SetSelectEndNormal();
}

/**
 * CFootyDoc::ParseRegulaerExpression
 * @brief K\Ƃĕp[X鏈
 */
void CFootyDoc::ParseRegulaerExpression(const wchar_t *szString,CRegExpContainer *pRegExp)
{
}


/*[EOF]*/
